# How To Git <3

## Table Of Contents
1. [Part 1 Setting up account](#Part1)
2. [Part 2 SSH keys](#Part2)
3. [Part 3 Setting up github desktop](#Part3)
4. [part 4 Finishing up](#Part4)
5. [Usage](#Usage)

## Part 1 Setting up account <a name="user-content-Part1"></a>
1. First of all [Register](https://git.redstealth.dev/user/sign_up) here.
2. Ask your organization owner to add you to the organization you can move on after telling them.

## Part 2 SSH keys <a name="user-content-Part2"></a>
1. Press the windows key, search for `cmd` and open the black box.
2. Write `ssh-keygen -t ed25519 -C "your_email@example.com"` replacing "your_email@example.com" with your own and press enter.
    * Press enter on all questions.
3. Press the windows key, search for `services` and press the blueish cogs.
4. Scroll down and find `OpenSSH Authentication Agent` Right click and press `Preferences`.
5. Open the `StartMethod` dropdown and select `Automatic (Delayed start)`.
6. Press apply then press start. you can now exit the `Services` app.
7. Open `File Explorer` and navigate to `C:\Users\"YOUR NAME"\.ssh`.
8. Make sure that you have File extentions enabled in the show menu of File Explorer.
9. Now Make a file and name it `config` with no extention.
10. Open `config` in notepad and write `AddKeysToAgent yes`.
11. Now back in cmd write `ssh-add .ssh/id_ed25519` and press enter.
    * You can close cmd now.
12. Open this [Link](https://git.redstealth.dev/user/settings/keys) and press add key.
13. Now in the `.ssh` folder we opened earlier you should find a `ìd_ed25519.pub`.
    * Open it and copy the contents.
14. Paste the text from `ìd_ed25519.pub` in the big box on the ssh key page we opened and rename it to something relevant like laptop or school.
15. Finish of this part by pressing the `Add Key` button under the big box.

## Part 3 Setting up github desktop <a name="user-content-Part3"></a>
1. First of all if you havent gotten github desktop downloaded yet then download it [here](https://desktop.github.com/) and install.
2. On the welcome page that opens after installation press the gray text that states `Skip this step`
3. Now fill in the user and email that you have for this page and press continue.
4. Once your inside there will be three buttons press `Clone a repository`.
5. Now open the url tab and contine here.
6. Go to the homepage of this [website](https://git.redstealth.dev) and find the `Organization` tab on the left.
7. Under the tab you should see a organization if you dont then ask your organization owner to add you again.
8. Now open that organization and press the big text in the empty space with your projects name on it.
9. Here you will have to find the `https and SSH` buttons and press the ssh one. 
10. Next to the `SSH` button you will now see a link. Copy that link and paste it in the url spot and change file location if needed.
11. Press the clone button.

## part 4 Finishing up <a name="user-content-Part4"></a>
1. Wait until you see that the spinning arrows have stopped and the text under says `Last fetched just now.`
2. Open unity hub and press the down arrow next to open and select add project from disk.
3. Find your project were you put it default dir is `C:\users\YOURNAME\Documents\github\PROJECTNAME` and select.
## Usage <a name="user-content-Usage"></a>

### Table of Usage
1. [What is git?](#WhatIsGit)
2. [Commit Pull Push](#Usage-cpp)
3. [Branches](#Usage-Bran)

### What is git <a name="user-content-WhatIsGit"></a>
`Git` is a repository management system and can be explained as a google drive folder shared to everyone added to it.\
But this drive folder is special because this folder can save your old changes additions and deletions of your files.\
Lets say you added a image long ago that you think isnt needed anymore and decide to delete it.\
But The whole program breaks and you nead that file back, so instead of remaking or finding it again you can yust use the special feature of git that allows you to undo the deletion and go back to before it happened.\
This is one strength but not the only one that Git has and there is one more i want to explain.\
So lets say that you are a big team of programmers that are working on a project but how would you go about getting the new code to work with the old.\
That is were Git's feature called branches come in they are basicaly a copy of the main folder branches of with some new code like maby you make a script that handles the main menu.\
And when that code is done you can do a `merge/pull request` and turn the branch around so that it connects back to the main project again.

### Commit Pull Push <a name="user-content-Usage-cpp"></a>
So first i will explain what these are and then i will show you how.\
Commiting is the time that you say to git that it should save your changes.\
This dose not upload it to the server yet it yust saves it localy so you can go back if you want to.\
Pulling and pushing are quite self explanatory they `download/upload` `your/the Servers` changes.\
One extra thing here is Fetching.\
Fetching is not the same as pulling it sounds like it could be but its not.\
Fetching is when you ask the server if it has some changes or new branches that you could download.\
1. Commiting in Github Desktop is quite easy to do this all you have to do is open Github Desktop and write a small message about what you changed after the last commit.\
The box to write in says `Summary (Required)` and is located bottom left corner.\
If you want a longer message you can write it in the bigger box that says `Description`.\
When you are done you yust press the big blue button with the name `Commit to (BranchName)`.\
2. Pushing in Github Desktop may be the easiest one because you only nead to do it after a commit so after commiting you will see a a button on the top bar that usualy says fetch is now blue and says push. If you press that then all your changes that you commited will be sent to the server so others can pull it.
3. Fetching is also easy you yust press `Fetch Origin` on the top button bar.
4. Pull is on the same button as fetch and is the time that you download the changes from the server.

### Branches <a name="user-content-Usage-Bran"></a>
